#include <amxmodx>
#include <amxmisc>
#include <cstrike> 
#include <fakemeta>
#include <csx>
#include <Commas>
#include <fun>
#include <ZP_Color_Chat>

// Stats
#define INT_MAX_PLAYERS_MENU 360
#define INT_MAX_PLAYERS 32
enum {
	INT_STATS_KILLS = 0,
	INT_STATS_DEATHS,
	INT_STATS_HS,
	INT_STATS_TKS,
	INT_STATS_SHOTS,
	INT_STATS_HITS,
	INT_STATS_DAMAGE
};
enum {
	INT_STATS_HIT_GENERIC = 0,
	INT_STATS_HIT_HEAD,
	INT_STATS_HIT_CHEST,
	INT_STATS_HIT_STOMACH,
	INT_STATS_HIT_LEFTARM,
	INT_STATS_HIT_RIGHTARM,
	INT_STATS_HIT_LEFTLEG,
	INT_STATS_HIT_RIGHTLEG
};

// Gag
new bool:Gagged[33];
#define MAXMINUTES 8

// Anti Say
new g_cSwears[ 256 ][ 32 ];
new g_iSwearsCount;

// Chat Tags
new g_iMsgID_SayText;
new g_szTags[50][20]; 
new Trie:g_tNameTagIndex; 
new g_iPlayerTag[33] 
new g_iAdminChatFlag = ADMIN_ALL;

// Anti Flod
new Float:g_Flooding[33] = {0.0, ...}
new g_Flood[33] = {0, ...}
new amx_flood_time;

// Fix Bug Say
new const gBlockTexts[][] = {
	"#",
	"$",
	"%"
};

// Hud Admin Color
#define HUD_HOLD_TIME 7.0
new Float:g_fHudPos[][] =
{ 
	{ 0.01, 0.53 }, 
	{ 0.01, 0.56 },
	{ 0.01, 0.59 },
	{ 0.01, 0.62 }
}; 
new g_iAvailableHud; 

// Access
#define CHATACCESS ADMIN_CHAT
new g_AdminChatFlag = ADMIN_CHAT;

public plugin_init()
{
	register_plugin("Chat Manager", "1.0", "The [RED] K!LLeR");
	
	// Language files
	register_dictionary("common.txt")

	// Gag
	register_concmd("amx_gag","cmdGag", ADMIN_CHAT, "<name or #userid> <minutes>");
	register_concmd("amx_ungag","cmdUnGag", ADMIN_CHAT, "<name or #userid>");

	//register_concmd("amx_reloadtags", "reloadtags");

	// Stats
	register_clcmd("say", "CLIENT_COMMAND_HOOK");
	register_clcmd("say_team", "CLIENT_COMMAND_HOOK");

	// Advertisements
	set_task(60.0 * 5.0, "FUNC_PRINT_CHAT1", 235267, _, _, "b");
	set_task(160.0 * 5.0, "FUNC_PRINT_CHAT2", 235267, _, _, "b");
	set_task(260.0 * 5.0, "FUNC_PRINT_CHAT3", 235267, _, _, "b");
	
	// Gag & Anti Say
	register_clcmd("say", "Client_Command_Say"); 
	register_clcmd("say_team", "Client_Command_Say_Team");
	
	// Chat Tags
	register_clcmd("say", "CmdSay"); 
	register_clcmd("say_team", "CmdSayTeam");

	// Fix Bug Chat
	register_clcmd("say", "Fix_Bug_Say");
	register_clcmd("say_team", "Fix_Bug_Say");

	// Rest Score
	register_clcmd("say /rs", "SayRs");

	// My Model
	register_clcmd("say /mymodel", "MyModel");

	// Show IP
	register_clcmd("say /IP", "SayIP");

	// Hud Admin Color
	register_clcmd("say", "clcmd_HandleSay"); 

	// Send Message To Admins
	register_clcmd("say_team", "cmdSayAdmin", 0, "@ <text> - displays message to admins")

	// My Flags
	register_clcmd("say /access", "MyFlags");
	register_clcmd("say /flags", "MyFlags");

	// Anti Flod
	register_clcmd("say", "Anti_Flod");
	register_clcmd("say_team", "Anti_Flod");
	amx_flood_time = register_cvar("amx_flood_time", "0.95")

	// Anti Say
	new iFile, cFile[ 512 ], cLine[ 32 ];
	get_localinfo("amxx_configsdir", cFile, 511);
	format(cFile, 511, "%s/restricted_things.ini", cFile);
	iFile = fopen( cFile, "rt" );
	while(!feof(iFile))
	{
		fgets(iFile, cLine, 31);
		trim(cLine );
		if(strlen(cLine))
		{
			copy(g_cSwears[g_iSwearsCount], 31, cLine);
			g_iSwearsCount++;
		}
	}
	fclose( iFile );

	// Chat Tags
	g_iMsgID_SayText = get_user_msgid("SayText");
	new szCommand[ 32 ], iFlags; 
	for( new i = 0; get_concmd( i, szCommand, charsmax( szCommand ), iFlags, "", 0, 0, -1 ); i++ ) 
	{ 
		if( equal( szCommand, "amx_chat" ) ) 
		{ 
			g_iAdminChatFlag = iFlags; 
			break; 
		} 
	}  
	g_tNameTagIndex = TrieCreate(); 
	Load_Tags(); 
}
public MyModel(id)
{
	new model[32];
	cs_get_user_model(id, model, charsmax(model));
	ZP_Color_Chat(id, "!g[ZP] !nYour model is: !g%s!n.", model);
}

public SayRs(id)
{
	cs_set_user_deaths(id, 0)
	set_user_frags(id, 0)
	cs_set_user_deaths(id, 0)
	set_user_frags(id, 0)
	
	// Get PlayeR Name
	new name[33]
	get_user_name(id, name, 32)
	ZP_Color_Chat(0, "!g[ZP] !t%s !nHas just reset his score.", name)
}

public MyFlags(id) 
{ 
	new szStringFlags[27]; 
	get_user_flags_string(id, szStringFlags, charsmax(szStringFlags)); 
	ZP_Color_Chat(id, "!g[ZP] !nYour flags are: !g%s!n.", szStringFlags); 
} 
get_user_flags_string(id, szFlags[], len) 
{ 
	return get_flags(get_user_flags(id), szFlags, len); 
}  

public SayIP(id)
{
	static address[32]
	get_cvar_string("net_address", address, charsmax(address));
	new szHostName[64];
	get_cvar_string("hostname", szHostName, charsmax(szHostName));

	ZP_Color_Chat(id,"!tServer Name: !g%s !n| !tIP: !g%s", szHostName, address);
}

public client_infochanged(id)
{
	new newname[32], oldname[32]
	get_user_name(id, oldname, charsmax(oldname))
	get_user_info(id, "name", newname, charsmax(newname))
	
	if(!equal(oldname, newname))
	{
		set_task(1.0, "Task_CheckName", id)
		g_iPlayerTag[id] = 0; 
		TrieGetCell(g_tNameTagIndex, newname, g_iPlayerTag[id] ) 
	}
}

// Send Message To Admins
public cmdSayAdmin(id)
{
	new said[2]
	read_argv(1, said, 1)
	
	if (said[0] != '@')
		return PLUGIN_CONTINUE
	
	new message[192], name[32], authid[32]
	new players[32], inum
	
	read_args(message, 191)
	remove_quotes(message)
	get_user_authid(id, authid, 31)
	get_user_name(id, name, 31)
	
	if(get_user_flags(id) & CHATACCESS)
		format(message, 191, "*ADMINS* %s:  %s", name, message[1])
	else
		format(message, 191, "*PLAYER* %s:  %s", name, message[1])

	get_players(players, inum)
	
	for (new i = 0; i < inum; ++i)
	{
		// dont print the message to the client that used the cmd if he has ADMIN_CHAT to avoid double printing
		if (players[i] != id && get_user_flags(players[i]) & g_AdminChatFlag)
			client_print(players[i], print_chat, "%s", message)
	}
	
	client_print(id, print_chat, "%s", message)
	
	return PLUGIN_HANDLED
}

// Stats
public CLIENT_COMMAND_HOOK( INT_PLAYER ) {
	static STRING_ARGUMENT[ 11 ];
	read_argv( 1, STRING_ARGUMENT, charsmax( STRING_ARGUMENT ) );
	
	// TOP
	if( equali( STRING_ARGUMENT, "top", 3 ) || equali( STRING_ARGUMENT, "/top", 4 ) ) {
		new HANDLE_MENU = menu_create( "Top", "FUNC_MENU_HANDLER" );
		new STRING_STATS[ 8 ], STRING_BODY[ 8 ], STRING_NAME[ 32 ], STRING_TEMP[ 128 ], STRING_TEMP_NUM[ 4 ], INT_VARIABLE, STATSNUM = get_statsnum( );
		
		if( STATSNUM < INT_MAX_PLAYERS_MENU )
			INT_VARIABLE = STATSNUM;
		
		else
			INT_VARIABLE = INT_MAX_PLAYERS_MENU;
		
		for( new INT_VARIABLE2 = 0; INT_VARIABLE2 < INT_VARIABLE; INT_VARIABLE2++ ) {
			get_stats( INT_VARIABLE2, STRING_STATS, STRING_BODY, STRING_NAME, charsmax( STRING_NAME ) );
			
			num_to_str( INT_VARIABLE2 + 1, STRING_TEMP_NUM, charsmax( STRING_TEMP_NUM ) );
			
			static KillString[16], DeathString[16];
		
			AddCommas(STRING_STATS[ INT_STATS_KILLS ], KillString, 15);
			AddCommas(STRING_STATS[ INT_STATS_DEATHS ], DeathString, 15);
			
			format( STRING_TEMP, charsmax( STRING_TEMP ), "\y%s \wRank: \r%i \wKills: \r%s \wDeaths: \r%s", STRING_NAME, INT_VARIABLE2 + 1, \
			KillString, DeathString );
			
			menu_additem( HANDLE_MENU, STRING_TEMP, STRING_TEMP_NUM, 0 );
		}
		
		menu_setprop( HANDLE_MENU, MPROP_EXITNAME, "Exit" );
		menu_setprop( HANDLE_MENU, MPROP_NEXTNAME, "Next" );
		menu_setprop( HANDLE_MENU, MPROP_BACKNAME, "Back" );
		
		menu_display( INT_PLAYER, HANDLE_MENU, 0 );
		
		client_cmd( INT_PLAYER, "spk buttons/button9" );
	}
	
	// RANK
	if( equali( STRING_ARGUMENT, "rank" ) || equali( STRING_ARGUMENT, "/rank" ) ) {
		new INT_RANK_POS, STRING_STATS[ 8 ], STRING_BODY[ 8 ], STRING_NAME[ 32 ];
		INT_RANK_POS = get_user_stats( INT_PLAYER, STRING_STATS, STRING_BODY );
		get_user_name( INT_PLAYER, STRING_NAME, charsmax( STRING_NAME ) );
		
		static RankString[16], StatsString[16], DeathString[16], KillString[16];

		AddCommas(INT_RANK_POS, RankString, 15);
		AddCommas(get_statsnum( ), StatsString, 15);
		AddCommas(STRING_STATS[ INT_STATS_KILLS ], DeathString, 15);
		AddCommas(STRING_STATS[ INT_STATS_DEATHS ], KillString, 15);
		
		ZP_Color_Chat( 0, "^x01Player^x03 %s^x01's rank is^x04 %s^x01/^x04%s^x01 with^x03 %s^x01 kills and^x03 %s^x01 deaths", STRING_NAME, \
		RankString, StatsString, DeathString, KillString );
		
		client_cmd( INT_PLAYER, "spk buttons/button9" );
	}
	
	// STATSME
	if( equali( STRING_ARGUMENT, "statsme" ) || equali( STRING_ARGUMENT, "/statsme" ) ) {
		new INT_RANK_POS, STRING_STATS[ 8 ], STRING_BODY[ 8 ], STRING_TEMP[ 128 ], STRING_STATS2[ 4 ];
		INT_RANK_POS = get_user_stats( INT_PLAYER, STRING_STATS, STRING_BODY );
		get_user_stats2( INT_PLAYER, STRING_STATS2 );
		
		new HANDLE_MENU = menu_create( "Rank", "FUNC_MENU_HANDLER" );
		
		static RankString[16];
		AddCommas(INT_RANK_POS, RankString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRank: \r%s", RankString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "1", 0 );
		
		static KillString[16];
		AddCommas(STRING_STATS[ INT_STATS_KILLS ], KillString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wKills: \r%s", KillString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "2", 0 );
		
		static DeathString[16];
		AddCommas(STRING_STATS[ INT_STATS_DEATHS ], DeathString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wDeaths: \r%s", DeathString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "3", 0 );
		
		static HeadString[16];
		AddCommas(STRING_STATS[ INT_STATS_HS ], HeadString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHeadshots: \r%s", HeadString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "4", 0 );
		
		static TeamKillString[16];
		AddCommas(STRING_STATS[ INT_STATS_TKS ], TeamKillString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wTeam kills: \r%s", TeamKillString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "5", 0 );
		
		static ShotString[16];
		AddCommas(STRING_STATS[ INT_STATS_SHOTS ], ShotString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wShots: \r%s", ShotString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "6", 0 );
		
		static HitString[16];
		AddCommas(STRING_STATS[ INT_STATS_HITS ], HitString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHits: \r%s", HitString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "7", 0 );
		
		static DamageString[16];
		AddCommas(STRING_STATS[ INT_STATS_DAMAGE ], DamageString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wDamage: \r%s", DamageString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "8", 0 );
		
		static HDString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_HEAD ], HDString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHead hits: \r%s", HDString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "13", 0 );
		
		static CHString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_CHEST ], CHString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wChest hits: \r%s", CHString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "14", 0 );
		
		static STString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_STOMACH ], STString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wStomach hits: \r%s", STString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "15", 0 );
		
		static LFString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_LEFTARM ], LFString, 15);

		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wLeftarm hits: \r%s", LFString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "16", 0 );
		
		static RHString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_RIGHTARM ], RHString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRightarm hits: \r%s", RHString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "17", 0 );
		
		static LHString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_LEFTLEG ], LHString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wLeftleg hits: \r%s", LHString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "18", 0 );
		
		static RHDString[16];
		AddCommas(STRING_BODY[ INT_STATS_HIT_RIGHTLEG ], RHDString, 15);
		
		format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRightleg hits: \r%s", RHDString );
		menu_additem( HANDLE_MENU, STRING_TEMP, "19", 0 );
		
		menu_setprop( HANDLE_MENU, MPROP_EXITNAME, "Exit" );
		menu_setprop( HANDLE_MENU, MPROP_NEXTNAME, "Next" );
		menu_setprop( HANDLE_MENU, MPROP_BACKNAME, "Back" );
		
		menu_display( INT_PLAYER, HANDLE_MENU, 0 );
		
		client_cmd( INT_PLAYER, "spk buttons/button9" );
	}
	
	// DAMAGE
	if( equali( STRING_ARGUMENT, "damage" ) || equali( STRING_ARGUMENT, "/damage" ) || equali( STRING_ARGUMENT, "/dmg" ) || equali( STRING_ARGUMENT, "dmg" ) ) {
		new HANDLE_MENU = menu_create( "Damage Top", "FUNC_MENU_HANDLER" );
		new STRING_STATS[ 8 ], STRING_BODY[ 8 ], STRING_NAME[ 32 ], STRING_TEMP[ 128 ], STRING_TEMP_NUM[ 4 ], INT_VARIABLE, STATSNUM = get_statsnum( );
		
		if( STATSNUM < INT_MAX_PLAYERS_MENU )
			INT_VARIABLE = STATSNUM;
		
		else
			INT_VARIABLE = INT_MAX_PLAYERS_MENU;
		
		for( new INT_VARIABLE2 = 0; INT_VARIABLE2 < INT_VARIABLE; INT_VARIABLE2++ ) {
			get_stats( INT_VARIABLE2, STRING_STATS, STRING_BODY, STRING_NAME, charsmax( STRING_NAME ) );
			
			num_to_str( INT_VARIABLE2 + 1, STRING_TEMP_NUM, charsmax( STRING_TEMP_NUM ) );
			
			static DamageString[16];
			AddCommas(STRING_STATS[ INT_STATS_DAMAGE ], DamageString, 15);
			
			format( STRING_TEMP, charsmax( STRING_TEMP ), "\y%s \wRank: \r%i \wDamage: \r%s%", \
			STRING_NAME, INT_VARIABLE2 + 1, DamageString );
			
			menu_additem( HANDLE_MENU, STRING_TEMP, STRING_TEMP_NUM, 0 );
		}
		
		menu_setprop( HANDLE_MENU, MPROP_EXITNAME, "Exit" );
		menu_setprop( HANDLE_MENU, MPROP_NEXTNAME, "Next" );
		menu_setprop( HANDLE_MENU, MPROP_BACKNAME, "Back" );
		
		menu_display( INT_PLAYER, HANDLE_MENU, 0 );
		
		client_cmd( INT_PLAYER, "spk buttons/button9" );
	}
}

public FUNC_MENU_HANDLER( INT_PLAYER, INT_MENU, INT_ITEM )
	return PLUGIN_HANDLED;

public FUNC_MENU_STATS_HANDLER( INT_PLAYER, INT_MENU, INT_ITEM ) {
	new STRING_COMMAND[ 6 ], STRING_NAME[ 64 ], INT_ACCESS, INT_CALLBACK, INT_VICTIM;
	menu_item_getinfo( INT_MENU, INT_ITEM, INT_ACCESS, STRING_COMMAND, charsmax( STRING_COMMAND ), STRING_NAME, charsmax( STRING_NAME ), INT_CALLBACK );
	INT_VICTIM = get_user_index( STRING_NAME );
	
	if( is_user_connected( INT_VICTIM ) )
		FUNC_STATS_ME( INT_PLAYER, INT_VICTIM );
	
	else {
		ZP_Color_Chat( INT_PLAYER, "^x01The player you choosed is disconnected!" );
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

public FUNC_STATS_ME( INT_PLAYER, VICTIM ) {
	new INT_RANK_POS, STRING_STATS[ 8 ], STRING_BODY[ 8 ], STRING_TEMP[ 128 ], STRING_STATS2[ 4 ], STRING_NAME[ 32 ];
	INT_RANK_POS = get_user_stats( VICTIM, STRING_STATS, STRING_BODY );
	get_user_stats2( VICTIM, STRING_STATS2 );
	get_user_name( VICTIM, STRING_NAME, charsmax( STRING_NAME ) );
	
	new HANDLE_MENU = menu_create( "Rank", "FUNC_MENU_HANDLER" );
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wUser: \r%s", STRING_NAME );
	menu_additem( HANDLE_MENU, STRING_TEMP, "1", 0 );
	
	static RankString[16];
	AddCommas(INT_RANK_POS, RankString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRank: \r%i", RankString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "2", 0 );
	
	static KillString[16];
	AddCommas(STRING_STATS[ INT_STATS_KILLS ], KillString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wKills: \r%i", KillString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "3", 0 );
	
	static DeathString[16];
	AddCommas(STRING_STATS[ INT_STATS_DEATHS ], DeathString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wDeaths: \r%i", DeathString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "4", 0 );
	
	static HeadString[16];
	AddCommas(STRING_STATS[ INT_STATS_HS ], HeadString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHeadshots: \r%i", HeadString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "5", 0 );
	
	static TeamKillString[16];
	AddCommas(STRING_STATS[ INT_STATS_TKS ], TeamKillString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wTeam kills: \r%i", TeamKillString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "6", 0 );
	
	static ShotString[16];
	AddCommas(STRING_STATS[ INT_STATS_SHOTS ], ShotString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wShots: \r%i", ShotString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "7", 0 );
	
	static HitString[16];
	AddCommas(STRING_STATS[ INT_STATS_HITS ], HitString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHits: \r%i", HitString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "8", 0 );
	
	static DamageString[16];
	AddCommas(STRING_STATS[ INT_STATS_DAMAGE ], DamageString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wDamage: \r%i", DamageString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "9", 0 );
	
	static HDString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_HEAD ], HDString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wHead hits: \r%i", HDString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "14", 0 );
	
	static CHString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_CHEST ], CHString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wChest hits: \r%i", CHString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "15", 0 );
	
	static STString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_STOMACH ], STString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wStomach hits: \r%i", STString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "16", 0 );
	
	static LFString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_LEFTARM ], LFString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wLeftarm hits: \r%i", LFString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "17", 0 );
	
	static RHString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_RIGHTARM ], RHString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRightarm hits: \r%i", RHString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "18", 0 );
	
	static LHString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_LEFTLEG ], LHString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wLeftleg hits: \r%i", LHString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "19", 0 );
	
	static RHDString[16];
	AddCommas(STRING_BODY[ INT_STATS_HIT_RIGHTLEG ], RHDString, 15);
	
	format( STRING_TEMP, charsmax( STRING_TEMP ), "\wRightleg hits: \r%i", RHDString );
	menu_additem( HANDLE_MENU, STRING_TEMP, "20", 0 );
	
	menu_setprop( HANDLE_MENU, MPROP_EXITNAME, "Exit" );
	menu_setprop( HANDLE_MENU, MPROP_NEXTNAME, "Next" );
	menu_setprop( HANDLE_MENU, MPROP_BACKNAME, "Back" );
	
	menu_display( INT_PLAYER, HANDLE_MENU, 0 );
	
	client_cmd( INT_PLAYER, "spk buttons/button9" );
}

public FUNC_PRINT_CHAT1()
{
	ZP_Color_Chat(0, "!g[ZP] !nCommands Available: !t/Rank!n, !t/Top!n, !t/Damage!n, !t/StatsMe!n.");
}

public FUNC_PRINT_CHAT2()
{
	ZP_Color_Chat(0, "!g[ZP] !nType !g/Vip !nFor Information About The !gVip!n.")
}

public FUNC_PRINT_CHAT3()
{
	ZP_Color_Chat(0, "!g[ZP] !nCommands Available: !t/Rs!n, !t/MyModel!n, !t/Access!n, !t/IP!n.")
}

// Hud Admin Color
public clcmd_HandleSay(id) 
{
	//if(!(get_user_flags(id) & ADMIN_CHAT))
		//return PLUGIN_CONTINUE;

	new szText[191]; 
	read_args(szText, charsmax(szText)); 
	remove_quotes(szText); 
    
	if(szText[0] != '@') 
        	return PLUGIN_CONTINUE; 

	new szName[32]; 
	get_user_name(id, szName, charsmax(szName)); 
            
	set_hudmessage(random_num(0, 255), random_num(0, 255), random_num(0, 255), g_fHudPos[g_iAvailableHud][0], g_fHudPos[g_iAvailableHud][1], 0, 12.0, HUD_HOLD_TIME, .channel = g_iAvailableHud);
	show_hudmessage(0, "%s: %s", szName, szText[1]);
	client_print(0, print_notify, "%s: %s", szName, szText[1]);
	g_iAvailableHud++; 

	if(g_iAvailableHud > 3) 
                g_iAvailableHud = 0;
        
	return PLUGIN_HANDLED; 
}

public Anti_Flod(id)
{
	new Float:maxChat = get_pcvar_float(amx_flood_time)
	if (maxChat)
	{
		new Float:nexTime = get_gametime()
		if (g_Flooding[id] > nexTime)
		{
			if (g_Flood[id] >= 3)
			{
				client_print(id, print_notify, "Stop spam in server or Ban ?")
				g_Flooding[id] = nexTime + maxChat + 3.0
				return PLUGIN_HANDLED
			}
			g_Flood[id]++
		}
		else if (g_Flood[id])
		{
			g_Flood[id]--
		}
		g_Flooding[id] = nexTime + maxChat
	}
	return PLUGIN_CONTINUE
}

public Task_CheckName( id )
{
	if( is_user_connected( id ) && !is_user_bot(id) && !is_user_hltv(id))
	{
		static cName[ 32 ], i;
		get_user_name( id, cName, 31 );
		
		new szHostName[ 64 ];
		get_cvar_string( "hostname", szHostName, charsmax(szHostName));

		for( i = 0; i < g_iSwearsCount; i++ )
		{
			if( containi( cName, g_cSwears[ i ] ) != -1 )
			{
				client_cmd( id, "name %s", szHostName);

				break;
			}
		}
	}
}

public cmdGag(id,level,cid)
{
	if(!cmd_access(id,level,cid,3))return PLUGIN_HANDLED;
	new arg[32], arg2[6], admin[32], player[32], min;
	read_argv(1,arg,31);
	read_argv(2,arg2,5);
	new target=cmd_target(id,arg,CMDTARGET_OBEY_IMMUNITY|CMDTARGET_ALLOW_SELF|CMDTARGET_NO_BOTS);
	if(!target)return PLUGIN_HANDLED;
	min = str_to_num(arg2);
	if(min >= MAXMINUTES)
	{
		client_print(id, print_console,"To much time!");
		return PLUGIN_HANDLED;
	}

	get_user_name(id,admin,31);
	get_user_name(target,player,31);
	if(Gagged[target])
	{
		client_print(id,print_console,"%s is allready gagged!",player);
		return PLUGIN_HANDLED;
	}

	Gagged[target] = true;
	ZP_Color_Chat(0, "!g[ZP] !t%s !ngagged !t%s !nfor !t%d !nminutes.", admin, player, min);
	set_task(float(min)*60, "AutoUngag", target);
	return PLUGIN_HANDLED;
}

public cmdUnGag(id,level,cid)
{
	if(!cmd_access(id,level,cid,2)) return PLUGIN_HANDLED;
	new arg[32],arg2[6],admin[32],player[32];
	read_argv(1,arg,31);
	read_argv(2,arg2,5);
	new target=cmd_target(id,arg,CMDTARGET_OBEY_IMMUNITY|CMDTARGET_ALLOW_SELF|CMDTARGET_NO_BOTS);
	if(!target)return PLUGIN_HANDLED;
	get_user_name(id,admin,31);
	get_user_name(target,player,31);
	if(!Gagged[target]){
		client_print(id,print_console,"[ZP] %s isn't gagged!",player);
		return PLUGIN_HANDLED;
	}
	Gagged[target]=false;
	ZP_Color_Chat(0, "!g[ZP] %s ungagged %s",admin,player);
	remove_task(target);
	return PLUGIN_HANDLED;
}

bool:IsValidMessage( iPlayer, bool:bTeamSay, szMessage[ ], iLen ) 
{ 
	read_args( szMessage, iLen ); 
	remove_quotes( szMessage ); 
  
	if( !szMessage[ 0 ] ) 
	{ 
		return false; 
	} 
  
	new iPos, cChar, i; 
	while( ( cChar = szMessage[ iPos ] ) == '@' ) 
	{ 
		i++; 
		iPos++; 
	} 
  
	if( i > 0 ) 
	{ 
		return ( !( bTeamSay ? ( i == 1 ) : ( 1 <= i <= 3 ) ) || !access( iPlayer, g_iAdminChatFlag ) ); 
	} 
  
	while( 0 < ( cChar = szMessage[ iPos++ ] ) <= 255 ) 
	{ 
		if( cChar != ' ' && cChar != '#' && cChar != '$' && cChar != '%') 
		{ 
			return true; 
		}
	} 
  
	return false; 
}

public Fix_Bug_Say(id)
{
	new args[192];
	read_args(args, charsmax(args));
	remove_quotes(args);
	
	for(new i = 0; i < sizeof(gBlockTexts); i++)
	{
		if(containi(args, gBlockTexts[i]) != -1 )
		{
           		return PLUGIN_HANDLED;
        	}
    	}
	return PLUGIN_CONTINUE;
}

public Client_Command_Say(id)
{
	if(!is_user_connected(id)) 
	{ 
		return PLUGIN_HANDLED_MAIN; 
	}

	// Gagged
	if(Gagged[id])
	{
		ZP_Color_Chat(id, "!g[ZP] !nYou have been gagged!");
		return PLUGIN_HANDLED;
	}

	// Anti Say
	new szHostName[ 64 ];
	get_cvar_string( "hostname", szHostName, charsmax(szHostName));
	
	static cPhrase[ 192 ], i;
	read_args( cPhrase, 191 );

	for( i = 0; i < g_iSwearsCount; i++ )
	{
		if( containi( cPhrase, g_cSwears[ i ] ) != -1 )
		{
			client_cmd( id, "say %s", szHostName );

			return PLUGIN_HANDLED;
		}
	}

	return PLUGIN_CONTINUE;
}

public Client_Command_Say_Team(id)
{
	// Gagged
	if(Gagged[id])
	{
		ZP_Color_Chat(id, "!g[ZP] !nYou have been gagged!");
		return PLUGIN_HANDLED;
	}

	// Anti Say
	new szHostName[ 64 ];
	get_cvar_string( "hostname", szHostName, charsmax( szHostName ) );
	
	static cPhrase[ 192 ], i;
	read_args( cPhrase, 191 );

	for( i = 0; i < g_iSwearsCount; i++ )
	{
		if( containi( cPhrase, g_cSwears[ i ] ) != -1 )
		{
			client_cmd( id, "say_team %s", szHostName );

			return PLUGIN_HANDLED;
		}
	}

	return PLUGIN_CONTINUE;
}

public CmdSay( iPlayer ) 
{ 
	if( !is_user_connected( iPlayer ) ) 
	{ 
		return PLUGIN_HANDLED_MAIN; 
	} 
  
	new szArgs[ 194 ]; 

  	if( !IsValidMessage( iPlayer, false, szArgs, charsmax( szArgs ) ) ) 
	{ 
		return PLUGIN_HANDLED_MAIN; 
	} 

	new iAlive = is_user_alive( iPlayer ); 
	new CsTeams:iTeam = cs_get_user_team( iPlayer ); 
  
	new iPlayers[ 32 ], iNum; 
	get_players( iPlayers, iNum ); 
  
	new szName[ 32 ]; 
	get_user_name( iPlayer, szName, charsmax( szName ) ); 
  
	new const szPrefixes[ 2 ][ CsTeams ][ ] = 
	{
		{
			"^1*DEAD* ",
			"^1*DEAD* ",
			"^1*DEAD* ",
			"^1*SPEC* "
		},
		{
			"",
			"",
			"",
			""
		}
	};
  
	new szMessage[ 192 ];
	  
	if (g_iPlayerTag[iPlayer])
	{
		formatex( szMessage, charsmax( szMessage ), "^1%s^4%s ^3%s^1 :  %s", szPrefixes[ iAlive ][ iTeam ], g_szTags[g_iPlayerTag[iPlayer]], szName, szArgs ); 
  	}
	else
	{
		formatex( szMessage, charsmax( szMessage ), "^1%s^3%s^1 :  %s", szPrefixes[ iAlive ][ iTeam ], szName, szArgs ); 
	}

	new iTarget; 
	for( new i = 0; i < iNum; i++ ) 
	{ 
		iTarget = iPlayers[ i ]; 
  
		if( iTarget == iPlayer || ( iAlive || is_user_connected( iTarget ) ) && is_user_alive( iTarget ) == iAlive ) 
		{ 
			message_begin( MSG_ONE_UNRELIABLE, g_iMsgID_SayText, _, iTarget ); 
			write_byte( iPlayer ); 
			write_string( szMessage ); 
			message_end( ); 
		} 
	}
	return PLUGIN_HANDLED_MAIN; 
} 
  
public CmdSayTeam( iPlayer ) 
{ 
	if( !g_iPlayerTag[iPlayer] ) 
	{ 
		return PLUGIN_CONTINUE; 
	} 
  
	if( !is_user_connected( iPlayer ) ) 
	{ 
		return PLUGIN_HANDLED_MAIN; 
	} 
  
	new szArgs[ 194 ]; 

  	if( !IsValidMessage( iPlayer, false, szArgs, charsmax( szArgs ) ) ) 
	{ 
		return PLUGIN_HANDLED_MAIN; 
	} 

	new iAlive = is_user_alive( iPlayer ); 
	new CsTeams:iTeam = CsTeams:( ( _:cs_get_user_team( iPlayer ) ) % 3 ); 
  
	new iPlayers[ 32 ], iNum; 
	get_players( iPlayers, iNum ); 
  
	new szName[ 32 ]; 
	get_user_name( iPlayer, szName, charsmax( szName ) ); 
  
	new const szPrefixes[ 2 ][ CsTeams ][ ] = 
	{
		{
			"(Spectator)",
			"*DEAD*(Terrorist)",
			"*DEAD*(Counter-Terrorist)",
			""
		},
		{
			"(Spectator)",
			"(Terrorist)",
			"(Counter-Terrorist)",
			""
		}
	}; 
  
	new szMessage[ 192 ]; 
  
	if (g_iPlayerTag[iPlayer])
	{
		formatex( szMessage, charsmax( szMessage ), "^1%s ^4%s ^3%s^1 :  %s", szPrefixes[ iAlive ][ iTeam ], g_szTags[g_iPlayerTag[iPlayer]], szName, szArgs ); 
  	}
	else
	{
		formatex( szMessage, charsmax( szMessage ), "^1%s^3%s^1 :  %s", szPrefixes[ iAlive ][ iTeam ], szName, szArgs ); 
	}
  
	for( new i = 0, iTeammate; i < iNum; i++ ) 
	{ 
		iTeammate = iPlayers[ i ]; 
  
		if( iTeammate == iPlayer || ( iAlive || is_user_connected( iTeammate ) ) && is_user_alive( iTeammate ) == iAlive && CsTeams:( ( _:cs_get_user_team( iTeammate ) ) % 3 ) == iTeam ) 
		{ 
			message_begin( MSG_ONE_UNRELIABLE, g_iMsgID_SayText, _, iTeammate ); 
			write_byte( iPlayer ); 
			write_string( szMessage ); 
			message_end( ); 
		}
	}
	return PLUGIN_HANDLED_MAIN; 
} 

public AutoUngag(id)
{
	if(!is_user_connected(id)) return PLUGIN_HANDLED;
	if(Gagged[id])
	{
		ZP_Color_Chat(id, "!g[ZP] !nYou have been ungagged!");
		Gagged[id] = false;
	}
	return PLUGIN_HANDLED;
}

public client_disconnect(id)
{
	if(Gagged[id])
	{
		//new name[32];
		//get_user_name(id,name,31);
		//client_print(0,print_chat,"[AMXGag] Gagged %s has left the game!",name);
		Gagged[id]=false;
		remove_task(id);
	}
}

public client_connect(id)
{
	if(Gagged[id])
	{
		Gagged[id] = false;
	}
}

public client_putinserver(id) 
{ 
	if( is_user_bot( id ) || is_user_hltv( id ) ) return PLUGIN_CONTINUE;
	set_task(1.0, "Task_CheckName", id );
  
	g_iPlayerTag[id] = 0;
	new szNameID[32]; 
	get_user_name(id, szNameID, charsmax(szNameID)); 
	TrieGetCell(g_tNameTagIndex, szNameID, g_iPlayerTag[id]) 
  
	return PLUGIN_HANDLED_MAIN; 
}

/*
public reloadtags(id)
{
	new iPlayers[ 32 ];
    	new iPlayersNum;
	get_players(iPlayers, iPlayersNum, "c" );        
	for( new i = 0 ; i < iPlayersNum ; i++ )
    	{
		g_iPlayerTag[i] = 0;
		//TrieGetCell(g_tNameTagIndex, i, g_iPlayerTag[i])
		set_task(1.0, "Load_Tags");
	}

	client_cmd(id, "Successfully reload player tags.");
	return 1;
}
*/

Load_Tags()
{
	new szFilePath[128]; 
	get_configsdir(szFilePath, charsmax(szFilePath)); 
	add(szFilePath, charsmax(szFilePath), "/player_tags.ini"); 
	new f = fopen(szFilePath, "rt"); 
	if(!f) 
	{
		log_to_file("ZP_Error.log", "Failed to open player_tags.ini file!");
		set_fail_state("Failed to open player_tags.ini file!"); 
	}
	new data[64], iTagCount = 0, szNameID[32], szTag[sizeof(g_szTags[])]; 
	while(!feof(f)) 
	{ 
		fgets(f, data, charsmax(data)) 
  
		trim(data) 
		if(!data[0] || data[0] == ';' || data[0] == '/' && data[1] == '/') continue; 
  
		parse(data, szNameID, charsmax(szNameID), szTag, charsmax(szTag)) 
		if(szNameID[0] && szTag[0]) 
		{ 
			iTagCount++ 
			copy(g_szTags[iTagCount], charsmax(g_szTags[]), szTag) 
			TrieSetCell(g_tNameTagIndex, szNameID, iTagCount) 
		} 
	} 
	fclose(f)
}